using FishFactoryFileImplement.Models;
using System.Xml.Linq;

namespace FishFactoryFileImplement
{
    public class DataFileSingleton
    {
        private static DataFileSingleton? instance;
        private readonly string IngredientFileName = "Ingredient.xml";
        private readonly string OrderFileName = "Order.xml";
        private readonly string CannedFileName = "Canned.xml";
        private readonly string ClientFileName = "Client.xml";
        private readonly string ImplementerFileName = "Implementer.xml";
        private readonly string MessageFileName = "Message.xml";
        public List<Ingredient> Ingredients { get; private set; }
        public List<Order> Orders { get; private set; }
        public List<Canned> ListCanned { get; private set; }
		public List<Client> Clients { get; private set; }
        public List<Implementer> Implementers { get; private set; }
        public List<Message> Messages { get; private set; }
        public static DataFileSingleton GetInstance()
        {
            if (instance == null)
            {
                instance = new DataFileSingleton();
            }
            return instance;
        }
        public void SaveIngredients() => SaveData(Ingredients, IngredientFileName,
            "Ingredients", x => x.GetXElement);

        public void SaveListCanned() => SaveData(ListCanned, CannedFileName,
            "ListCanned", x => x.GetXElement);

        public void SaveOrders() => SaveData(Orders, OrderFileName, "Orders", x => x.GetXElement);

        public void SaveClients() => SaveData(Clients, ClientFileName, "Clients", x => x.GetXElement);
		
		public void SaveImplementers() => SaveData(Implementers, ImplementerFileName, "Implementers", x => x.GetXElement);
        
		public void SaveMessages() => SaveData(Messages, MessageFileName, "Messages", x => x.GetXElement);
        
		private DataFileSingleton()
        {
            Ingredients = LoadData(IngredientFileName, "Ingredient", x => Ingredient.Create(x)!)!;
            ListCanned = LoadData(CannedFileName, "Canned", x => Canned.Create(x)!)!;
            Orders = LoadData(OrderFileName, "Order", x => Order.Create(x)!)!;
            Clients = LoadData(ClientFileName, "Client", x => Client.Create(x)!)!;
			Implementers = LoadData(ImplementerFileName, "Implementer", x => Implementer.Create(x)!)!;
            Messages = LoadData(MessageFileName, "Message", x => Message.Create(x)!)!;
        }

        private static List<T>? LoadData<T>(string filename, string xmlNodeName,
            Func<XElement, T> selectFunction)
        {
            if (File.Exists(filename))
            {
                return
                    XDocument.Load(filename)?.Root?.Elements(xmlNodeName)?.Select(selectFunction)?.ToList();
            }
            return new List<T>();
        }

        private static void SaveData<T>(List<T> data, string filename, string
            xmlNodeName, Func<T, XElement> selectFunction)
        {
            if (data != null)
            {
                new XDocument(new XElement(xmlNodeName, data.Select(selectFunction).ToArray())).Save(filename);
            }
        }
    }
}